Subject: Re: [PATCH net-next 2/2] net: original ingress device index in PKTINFO

From: Shmulik Ladkani <[email-masked]>
Date: Sat, 7 May 2016 22:08:30 +0300

Hi,

On Sat, 7 May 2016 08:53:44 -0600 David Ahern <[email-masked]> wrote:
> >> @@ -1193,7 +1193,12 @@ void ipv4_pktinfo_prepare(const struct sock *sk, struct sk_buff *skb)
> >>   		       ipv6_sk_rxinfo(sk);
> >>
> >>   	if (prepare && skb_rtable(skb)) {
> >> -		pktinfo->ipi_ifindex = inet_iif(skb);
> >> +		/* skb->cb is overloaded: prior to this point it is IP{6}CB
> >> +		 * which has interface index (iif) as the first member of the
> >> +		 * underlying inet{6}_skb_parm struct. This code then overlays
> >> +		 * PKTINFO_SKB_CB and in_pktinfo also has iif as the first
> >> +		 * element so the iif is picked up from the prior IPCB
> >> +		 */  
> >
> > Better if there was a guarantee in the code that inet_skb_parm layout stays
> > that way. Or instead just explicitly assign the iif.  
> 
> At this point inet_iif points to the vrf device so can't use it.

Initially I was thinking about explicitly getting the iif out of the
IPCB first, then assign to ipi_ifindex. Seems more readable, and less
fragile. However this depends on the IPCB/IP6CB layout relationship as
well (iif being first on both).

I assume documenting the IP{6}CB/PKTINFO_SKB_CB layout relationship at the
struct definitions would be beneficial.

Regards,
Shmulik